]> git.madduck.net Git - code/myrepos.git/blobdiff - mr

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

* Add ability to reorder repos, if you want mr to act on a given repo first
[code/myrepos.git] / mr
diff --git a/mr b/mr
index e15019e3b8092e74a250b9f902cd02a61d2b922c..0bded236e0e782a267a1d6e2abe5672503197912 100755 (executable)
--- a/mr
+++ b/mr
@@ -1,5 +1,7 @@
 #!/usr/bin/perl
 
+#man{{{
+
 =head1 NAME
 
 mr - a Multiple Repository management tool
@@ -18,28 +20,26 @@ B<mr> [options] diff
 
 B<mr> [options] log
 
-B<mr> [options] register repository
+B<mr> [options] register [repository]
 
-B<mr> [options] config section [parameter=[value] ...]
+B<mr> [options] config section ["parameter=[value]" ...]
 
 B<mr> [options] action [params ...]
 
 =head1 DESCRIPTION
 
-B<mr> is a Multiple Repository management tool. It allows you to register a
-set of repositories in a .mrconfig file, and then checkout, update, or
-perform other actions on the repositories as if they were one big
-respository.
-
-Any mix of revision control systems can be used with B<mr>, and you can
-define arbitrary actions for commands like "update", "checkout", or "commit".
+B<mr> is a Multiple Repository management tool. It can checkout, update, or
+perform other actions on a set of repositories as if they were one combined
+respository. It supports any combination of subversion, git, cvs, mecurial and
+bzr repositories, and support for other revision control systems can easily be
+added.
 
-B<mr> cds into and operates on all registered repsitories at or below your
+B<mr> cds into and operates on all registered repositories at or below your
 working directory. Or, if you are in a subdirectory of a repository that
 contains no other registered repositories, it will stay in that directory,
 and work on only that repository,
 
-The predefined commands should be fairly familiar to users of any revision
+These predefined commands should be fairly familiar to users of any revision
 control system:
 
 =over 4
@@ -74,25 +74,47 @@ Show a diff of uncommitted changes.
 
 Show the commit log.
 
+=back
+
+These commands are also available:
+
+=over 4
+
 =item list (or ls)
 
 List the repositories that mr will act on.
 
 =item register
 
-The next parameter is the directory of an existing repository. The
-repository will be registered in the mrconfig file.
+Register an existing repository in a mrconfig file. By default, the
+repository in the current directory is registered, or you can specify a
+directory to register.
+
+The mrconfig file that is modified is chosen by either the -c option, or by
+looking for the closest known one at or below the current directory.
 
 =item config
 
-Modifies the mrconfig file. The next parameter is the name of the section
-to add or modify, and it is followed by one or more instances of
-"parameter=value". Use "parameter=" to remove a parameter. 
+Adds, modifies, removes, or prints a value from a mrconfig file. The next
+parameter is the name of the section the value is in. To add or modify
+values, use one or more instances of "parameter=value". Use "parameter=" to
+remove a parameter. Use just "parameter" to get the value of a parameter.
 
 For example, to add (or edit) a repository in src/foo:
 
   mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
 
+To show the command that mr uses to update the repository in src/foo:
+
+  mr config src/foo update
+
+To see the built-in library of shell functions contained in mr:
+
+  mr config DEFAULT lib
+
+The ~/.mrconfig file is used by default. To use a different config file,
+use the -c option.
+
 =item help
 
 Displays this help.
@@ -119,13 +141,28 @@ the current working directory.
 
 =item -c mrconfig
 
-Use the specified mrconfig file, instead of looking for one in your home
-directory.
+Use the specified mrconfig file. The default is B<~/.mrconfig>
 
 =item -v
 
 Be verbose.
 
+=item -s
+
+Expand the statistics line displayed at the end to include information
+about exactly which repositories failed and were skipped, if any.
+
+=item -n
+
+Just operate on the repository for the current directory, do not 
+recurse into deeper repositories.
+
+=item -j number
+
+Run the specified number of jobs in parallel. This can greatly speed up
+operations such as updates. It is not recommended for interactive
+operations.
+
 =back
 
 =head1 FILES
@@ -141,10 +178,13 @@ Here is an example .mrconfig file:
   chain = true
 
   [src/linux-2.6]
-  checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git
+  checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
+       cd linux-2.6 &&
+       git checkout -b mybranch origin/master
 
 The .mrconfig file uses a variant of the INI file format. Lines starting with
-"#" are comments. Lines ending with "\" are continued on to the next line.
+"#" are comments. Values can be continued to the following line by
+indenting the line with whitespace.
 
 The "DEFAULT" section allows setting default values for the sections that
 come after it.
@@ -158,17 +198,20 @@ that contains the mrconfig file, but you can also choose to use absolute
 paths.
 
 Within a section, each parameter defines a shell command to run to handle a
-given action. mr contains default handlers for the "update", "status", and
-"commit" actions, so normally you only need to specify what to do for
-"checkout".
+given action. mr contains default handlers for "update", "status",
+"commit", and other standard actions. Normally you only need to specify what
+to do for "checkout".
 
 Note that these shell commands are run in a "set -e" shell
 environment, where any additional parameters you pass are available in
 "$@". The "checkout" command is run in the parent of the repository
 directory, since the repository isn't checked out yet. All other commands
 are run inside the repository, though not necessarily at the top of it.
+
 The "MR_REPO" environment variable is set to the path to the top of the
-repository.
+repository. The "MR_CONFIG" environment variable is set to the .mrconfig file
+that defines the repo being acted on, or, if the repo is not yet in a config
+file, the .mrconfig file that should be modified to register the repo.
 
 A few parameters have special meanings:
 
@@ -176,23 +219,35 @@ A few parameters have special meanings:
 
 =item skip
 
-If the "skip" parameter is set and its command returns nonzero, then B<mr>
-will skip acting on that repository.
+If the "skip" parameter is set and its command returns true, then B<mr>
+will skip acting on that repository. The command is passed the action
+name in $1.
+
+Here are two examples. The first skips the repo unless
+mr is run by joey. The second uses the hours_since function
+(included in mr's built-in library) to skip updating the repo unless it's
+been at least 12 hours since the last update.
+
+  skip = test $(whoami) != joey
+  skip = [ "$1" = update ] && ! hours_since "$1" 12
+
+=item order
+
+The "order" parameter can be used to override the default ordering of
+repositories. The default order value is 10. Use smaller values to make
+repositories be processed earlier, and larger values to make repositories
+be processed later.
+
+Note that if a repository is located in a subdirectory of another
+repository, ordering it to be processed earlier is not recommended, as this
+can cause confusion during checkouts.
 
 =item chain
 
-If the "chain" parameter is set and its command returns nonzero, then B<mr>
+If the "chain" parameter is set and its command returns true, then B<mr>
 will try to load a .mrconfig file from the root of the repository. (You
 should avoid chaining from repositories with untrusted committers.)
 
-=item deleted
-
-If the "deleted" parameter is set and its command returns nonzero, then
-B<mr> will treat the repository as deleted. It won't ever actually delete
-the repository, but it will warn if it sees the repsoitory's directory.
-This is useful when one mrconfig file is shared amoung multiple machines,
-to keep track of and remember to delete old repositories.
-
 =item lib
 
 The "lib" parameter can specify some shell code that will be run before each
@@ -211,23 +266,45 @@ http://kitenet.net/~joey/code/mr/
 
 =cut
 
+#}}}
+
 use warnings;
 use strict;
 use Getopt::Long;
 use Cwd qw(getcwd abs_path);
+use POSIX "WNOHANG";
+use constant {
+       OK => 0,
+       FAILED => 1,
+       SKIPPED => 2,
+       ABORT => 3,
+};
+
+$SIG{INT}=sub {
+       print STDERR "mr: interrupted\n";
+       exit 2;
+};
 
+$ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
+my $config_overridden=0;
 my $directory=getcwd();
-my $config="$ENV{HOME}/.mrconfig";
 my $verbose=0;
+my $stats=0;
+my $no_recurse=0;
+my $jobs=1;
 my %config;
+my %configfiles;
 my %knownactions;
 my %alias;
 
 Getopt::Long::Configure("no_permute");
 my $result=GetOptions(
        "d|directory=s" => sub { $directory=abs_path($_[1]) },
-       "c|config=s" => \$config,
-       "verbose" => \$verbose,
+       "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
+       "v|verbose" => \$verbose,
+       "s|stats" => \$stats,
+       "n|no-recurse" => \$no_recurse,
+       "j|jobs=i" => \$jobs,
 );
 if (! $result || @ARGV < 1) {
        die("Usage: mr [-d directory] action [params ...]\n".
@@ -235,16 +312,23 @@ if (! $result || @ARGV < 1) {
 
 }
 
-loadconfig(\*DATA);
-loadconfig($config);
-#use Data::Dumper;
-#print Dumper(\%config);
-
+# Make sure MR_CONFIG is an absolute path, but don't use abs_path since
+# the config file might be a symlink to elsewhere, and the directory it's
+# in is significant.
+if ($ENV{MR_CONFIG} !~ /^\//) {
+       $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
+}
+# Try to set MR_PATH to the path to the program.
 eval {
        use FindBin qw($Bin $Script);
        $ENV{MR_PATH}=$Bin."/".$Script;
 };
 
+loadconfig(\*DATA);
+loadconfig($ENV{MR_CONFIG});
+#use Data::Dumper;
+#print Dumper(\%config);
+
 # alias expansion and command stemming
 my $action=shift @ARGV;
 if (exists $alias{$action}) {
@@ -266,6 +350,7 @@ if (! exists $knownactions{$action}) {
        }
 }
 
+# commands that do not operate on all repos
 if ($action eq 'help') {
        exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
 }
@@ -275,25 +360,50 @@ elsif ($action eq 'config') {
        }
        my $section=shift;
        if ($section=~/^\//) {
-               # try to convert to a path relative to $config's dir
-               my ($dir)=$config=~/^(.*\/)[^\/]+$/;
+               # try to convert to a path relative to the config file
+               my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
+               $dir=abs_path($dir);
+               $dir.="/" unless $dir=~/\/$/;
                if ($section=~/^\Q$dir\E(.*)/) {
                        $section=$1;
                }
        }
-       my %fields;
+       my %changefields;
        foreach (@ARGV) {
                if (/^([^=]+)=(.*)$/) {
-                       $fields{$1}=$2;
+                       $changefields{$1}=$2;
                }
                else {
-                       die "mr config: expected parameter=value, not \"$_\"\n";
+                       my $found=0;
+                       foreach my $topdir (sort keys %config) {
+                               if (exists $config{$topdir}{$section} &&
+                                   exists $config{$topdir}{$section}{$_}) {
+                                       print $config{$topdir}{$section}{$_}."\n";
+                                       $found=1;
+                                       last if $section eq 'DEFAULT';
+                               }
+                       }
+                       if (! $found) {
+                               die "mr $action: $section $_ not set\n";
+                       }
                }
        }
-       modifyconfig($config, $section, %fields);
+       modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
        exit 0;
 }
 elsif ($action eq 'register') {
+       if (! $config_overridden) {
+               # Find the closest known mrconfig file to the current
+               # directory.
+               $directory.="/" unless $directory=~/\/$/;
+               foreach my $topdir (reverse sort keys %config) {
+                       next unless length $topdir;
+                       if ($directory=~/^\Q$topdir\E/) {
+                               $ENV{MR_CONFIG}=$configfiles{$topdir};
+                               last;
+                       }
+               }
+       }
        my $command="set -e; ".$config{''}{DEFAULT}{lib}."\n".
                "my_action(){ $config{''}{DEFAULT}{$action}\n }; my_action ".
                join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
@@ -301,74 +411,116 @@ elsif ($action eq 'register') {
        exec($command) || die "exec: $!";
 }
 
+# an ordered list of repos
+my @list;
+foreach my $topdir (sort keys %config) {
+       foreach my $subdir (sort keys %{$config{$topdir}}) {
+               push @list, {
+                       topdir => $topdir,
+                       subdir => $subdir,
+                       order => $config{$topdir}{$subdir}{order},
+               };
+       }
+}
+@list = sort {
+               $a->{order}  <=> $b->{order}
+                            ||
+               $a->{topdir} cmp $b->{topdir}
+                            ||
+               $a->{subdir} cmp $b->{subdir}
+       } @list;
+
 # work out what repos to act on
 my @repos;
 my $nochdir=0;
-foreach my $topdir (sort keys %config) {
-       foreach my $subdir (sort keys %{$config{$topdir}}) {
+foreach my $repo (@list) {
+       my $topdir=$repo->{topdir};
+       my $subdir=$repo->{subdir};
+
+       next if $subdir eq 'DEFAULT';
+       my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
+       my $d=$directory;
+       $dir.="/" unless $dir=~/\/$/;
+       $d.="/" unless $d=~/\/$/;
+       next if $no_recurse && $d ne $dir;
+       next if $dir ne $d && $dir !~ /^\Q$d\E/;
+       push @repos, [$dir, $topdir, $subdir];
+}
+if (! @repos) {
+       # fallback to find a leaf repo
+       foreach my $repo (@list) {
+               my $topdir=$repo->{topdir};
+               my $subdir=$repo->{subdir};
+               
                next if $subdir eq 'DEFAULT';
                my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
                my $d=$directory;
                $dir.="/" unless $dir=~/\/$/;
                $d.="/" unless $d=~/\/$/;
-               next if $dir ne $directory && $dir !~ /^\Q$directory\E/;
-               push @repos, [$dir, $topdir, $subdir];
-       }
-}
-if (! @repos) {
-       # fallback to find a leaf repo
-       LEAF: foreach my $topdir (reverse sort keys %config) {
-               foreach my $subdir (reverse sort keys %{$config{$topdir}}) {
-                       next if $subdir eq 'DEFAULT';
-                       my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
-                       my $d=$directory;
-                       $dir.="/" unless $dir=~/\/$/;
-                       $d.="/" unless $d=~/\/$/;
-                       if ($d=~/^\Q$dir\E/) {
-                               push @repos, [$dir, $topdir, $subdir];
-                               last LEAF;
-                       }
+               if ($d=~/^\Q$dir\E/) {
+                       push @repos, [$dir, $topdir, $subdir];
+                       last;
                }
        }
        $nochdir=1;
 }
 
-my (@failed, @successful, @skipped);
-foreach my $repo (@repos) {
-       action($action, @$repo);
+# run the action on each repository and print stats
+my (@ok, @failed, @skipped);
+if ($jobs > 1) {
+       mrs(@repos);
+}
+else {
+       foreach my $repo (@repos) {
+               record($repo, action($action, @$repo));
+               print "\n";
+       }
+}
+if (! @ok && ! @failed && ! @skipped) {
+       die "mr $action: no repositories found to work on\n";
+}
+print "mr $action: finished (".join("; ",
+       showstat($#ok+1, "ok", "ok"),
+       showstat($#failed+1, "failed", "failed"),
+       showstat($#skipped+1, "skipped", "skipped"),
+).")\n";
+if ($stats) {
+       if (@skipped) {
+               print "mr $action: (skipped: ".join(" ", @skipped).")\n";
+       }
+       if (@failed) {
+               print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
+       }
+}
+if (@failed) {
+       exit 1;
 }
+elsif (! @ok && @skipped) {
+       exit 1;
+}
+exit 0;
 
-sub action {
+sub action { #{{{
        my ($action, $dir, $topdir, $subdir) = @_;
-       
-       my $lib= exists $config{$topdir}{$subdir}{lib} ?
-                       $config{$topdir}{$subdir}{lib}."\n" : "";
 
-       if (exists $config{$topdir}{$subdir}{deleted}) {
-               if (! -d $dir) {
-                       return;
-               }
-               else {
-                       my $test="set -e;".$lib.$config{$topdir}{$subdir}{deleted};
-                       print "mr $action: running deleted test >>$test<<\n" if $verbose;
-                       my $ret=system($test);
-                       if ($ret >> 8 == 0) {
-                               print STDERR "mr error: $dir should be deleted yet still exists\n\n";
-                               push @failed, $dir;
-                               return;
-                       }
-               }
-       }
+       $ENV{MR_CONFIG}=$configfiles{$topdir};
+       my $lib=exists $config{$topdir}{$subdir}{lib} ?
+                      $config{$topdir}{$subdir}{lib}."\n" : "";
 
        if ($action eq 'checkout') {
                if (-d $dir) {
                        print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
-                       push @skipped, $dir;
-                       return;
+                       return SKIPPED;
                }
+
                $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
+
+               if (! -d $dir) {
+                       print "mr $action: creating parent directory $dir\n" if $verbose;
+                       system("mkdir", "-p", $dir);
+               }
        }
-       elsif ($action eq 'update') {
+       elsif ($action =~ /update/) {
                if (! -d $dir) {
                        return action("checkout", $dir, $topdir, $subdir);
                }
@@ -377,23 +529,33 @@ sub action {
        $ENV{MR_REPO}=$dir;
 
        if (exists $config{$topdir}{$subdir}{skip}) {
-               my $test="set -e;".$lib.$config{$topdir}{$subdir}{skip};
+               my $test="set -e;".$lib.
+                       "my_action(){ $config{$topdir}{$subdir}{skip}\n }; my_action '$action'";
                print "mr $action: running skip test >>$test<<\n" if $verbose;
                my $ret=system($test);
+               if ($ret != 0) {
+                       if (($? & 127) == 2) {
+                               print STDERR "mr $action: interrupted\n";
+                               return ABORT;
+                       }
+                       elsif ($? & 127) {
+                               print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
+                               return ABORT;
+                       }
+               }
                if ($ret >> 8 == 0) {
                        print "mr $action: $dir skipped per config file\n" if $verbose;
-                       push @skipped, $dir;
-                       return;
+                       return SKIPPED;
                }
        }
        
        if (! $nochdir && ! chdir($dir)) {
                print STDERR "mr $action: failed to chdir to $dir: $!\n";
-               push @failed, $dir;
+               return FAILED;
        }
        elsif (! exists $config{$topdir}{$subdir}{$action}) {
                print STDERR "mr $action: no defined $action command for $topdir$subdir, skipping\n";
-               push @skipped, $dir;
+               return SKIPPED;
        }
        else {
                if (! $nochdir) {
@@ -408,24 +570,124 @@ sub action {
                print STDERR "mr $action: running >>$command<<\n" if $verbose;
                my $ret=system($command);
                if ($ret != 0) {
+                       if (($? & 127) == 2) {
+                               print STDERR "mr $action: interrupted\n";
+                               return ABORT;
+                       }
+                       elsif ($? & 127) {
+                               print STDERR "mr $action: received signal ".($? & 127)."\n";
+                               return ABORT;
+                       }
                        print STDERR "mr $action: failed ($ret)\n" if $verbose;
-                       push @failed, $dir;
                        if ($ret >> 8 != 0) {
                                print STDERR "mr $action: command failed\n";
                        }
                        elsif ($ret != 0) {
                                print STDERR "mr $action: command died ($ret)\n";
                        }
+                       return FAILED;
                }
                else {
-                       push @successful, $dir;
+                       if ($action eq 'checkout' && ! -d $dir) {
+                               print STDERR "mr $action: $dir missing after checkout\n";;
+                               return FAILED;
+                       }
+
+                       return OK;
                }
+       }
+} #}}}
 
-               print "\n";
+# run actions on multiple repos, in parallel
+sub mrs { #{{{
+       $| = 1;
+       my @active;
+       my @fhs;
+       my @out;
+       my $running=0;
+       while (@fhs or @repos) {
+               while ($running < $jobs && @repos) {
+                       $running++;
+                       my $repo = shift @repos;
+                       pipe(my $outfh, CHILD_STDOUT);
+                       pipe(my $errfh, CHILD_STDERR);
+                       my $pid;
+                       unless ($pid = fork) {
+                               die "mr $action: cannot fork: $!" unless defined $pid;
+                               open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
+                               open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
+                               close CHILD_STDOUT;
+                               close CHILD_STDERR;
+                               close $outfh;
+                               close $errfh;
+                               exit action($action, @$repo);
+                       }
+                       close CHILD_STDOUT;
+                       close CHILD_STDERR;
+                       push @active, [$pid, $repo];
+                       push @fhs, [$outfh, $errfh];
+                       push @out, ['',     ''];
+               }
+               my ($rin, $rout) = ('','');
+               my $nfound;
+               foreach my $fh (@fhs) {
+                       next unless defined $fh;
+                       vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
+                       vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
+               }
+               $nfound = select($rout=$rin, undef, undef, 1);
+               foreach my $channel (0, 1) {
+                       foreach my $i (0..$#fhs) {
+                               next unless defined $fhs[$i];
+                               my $fh = $fhs[$i][$channel];
+                               next unless defined $fh;
+                               if (vec($rout, fileno($fh), 1) == 1) {
+                                       my $r = '';
+                                       if (sysread($fh, $r, 1024) == 0) {
+                                               close($fh);
+                                               $fhs[$i][$channel] = undef;
+                                               if (! defined $fhs[$i][0] &&
+                                                   ! defined $fhs[$i][1]) {
+                                                       waitpid($active[$i][0], 0);
+                                                       print STDOUT $out[$i][0];
+                                                       print STDERR $out[$i][1];
+                                                       print "\n";
+                                                       record($active[$i][1], $? >> 8);
+                                                       splice(@fhs, $i, 1);
+                                                       splice(@active, $i, 1);
+                                                       splice(@out, $i, 1);
+                                                       $running--;
+                                               }
+                                       }
+                                       $out[$i][$channel] .= $r;
+                               }
+                       }
+               }
        }
-}
+} #}}}
+
+sub record { #{{{
+       my $dir=shift()->[0];
+       my $ret=shift;
 
-sub showstat {
+       if ($ret == OK) {
+               push @ok, $dir;
+       }
+       elsif ($ret == FAILED) {
+               push @failed, $dir;
+       }
+       elsif ($ret == SKIPPED) {
+               push @skipped, $dir;
+       }
+       elsif ($ret == ABORT) {
+               exit 1;
+       }
+       else {
+               die "unknown exit status $ret";
+       }
+} #}}}
+
+sub showstat { #{{{
        my $count=shift;
        my $singular=shift;
        my $plural=shift;
@@ -433,25 +695,10 @@ sub showstat {
                return "$count ".($count > 1 ? $plural : $singular);
        }
        return;
-}
-if (! @successful && ! @failed && ! @skipped) {
-       die "mr $action: no repositories found to work on\n";
-}
-print "mr $action: finished (".join("; ",
-       showstat($#successful+1, "successful", "successful"),
-       showstat($#failed+1, "failed", "failed"),
-       showstat($#skipped+1, "skipped", "skipped"),
-).")\n";
-if (@failed) {
-       exit 1;
-}
-elsif (! @successful && @skipped) {
-       exit 1;
-}
-exit 0;
+} #}}}
 
 my %loaded;
-sub loadconfig {
+sub loadconfig { #{{{
        my $f=shift;
 
        my @toload;
@@ -459,8 +706,8 @@ sub loadconfig {
        my $in;
        my $dir;
        if (ref $f eq 'GLOB') {
-               $in=$f; 
                $dir="";
+               $in=$f; 
        }
        else {
                if (! -e $f) {
@@ -473,39 +720,54 @@ sub loadconfig {
                }
                $loaded{$absf}=1;
 
-               print "mr: loading config $f\n" if $verbose;
-               open($in, "<", $f) || die "mr: open $f: $!\n";
                ($dir)=$f=~/^(.*\/)[^\/]+$/;
                if (! defined $dir) {
                        $dir=".";
                }
                $dir=abs_path($dir)."/";
+               
+               if (! exists $configfiles{$dir}) {
+                       $configfiles{$dir}=$f;
+               }
 
                # copy in defaults from first parent
                my $parent=$dir;
-               while ($parent=~s/^(.*)\/[^\/]+\/?$/$1/) {
+               while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
+                       if ($parent eq '/') {
+                               $parent="";
+                       }
                        if (exists $config{$parent} &&
                            exists $config{$parent}{DEFAULT}) {
                                $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
                                last;
                        }
                }
+               
+               print "mr: loading config $f\n" if $verbose;
+               open($in, "<", $f) || die "mr: open $f: $!\n";
        }
+       my @lines=<$in>;
+       close $in;
 
        my $section;
-       while (<$in>) {
+       my $line=0;
+       while (@lines) {
+               $_=shift @lines;
+               $line++;
                chomp;
                next if /^\s*\#/ || /^\s*$/;
-               if (/^\s*\[([^\]]*)\]\s*$/) {
+               if (/^\[([^\]]*)\]\s*$/) {
                        $section=$1;
                }
-               elsif (/^\s*(\w+)\s*=\s*(.*)/) {
+               elsif (/^(\w+)\s*=\s*(.*)/) {
                        my $parameter=$1;
                        my $value=$2;
 
-                       # continuation line
-                       while ($value=~/(.*)\\$/s) {
-                               $value=$1."\n".<$in>;
+                       # continued value
+                       while (@lines && $lines[0]=~/^\s(.+)/) {
+                               shift(@lines);
+                               $line++;
+                               $value.="\n$1";
                                chomp $value;
                        }
 
@@ -529,24 +791,34 @@ sub loadconfig {
                                $knownactions{$parameter}=1;
                                if ($parameter eq 'chain' &&
                                    length $dir && $section ne "DEFAULT" &&
-                                   -e $dir.$section."/.mrconfig" &&
-                                   system($value) >> 8 == 0) {
-                                       push @toload, $dir.$section."/.mrconfig";
+                                   -e $dir.$section."/.mrconfig") {
+                                       my $ret=system($value);
+                                       if ($ret != 0) {
+                                               if (($? & 127) == 2) {
+                                                       print STDERR "mr $action: chain test interrupted\n";
+                                                       exit 2;
+                                               }
+                                               elsif ($? & 127) {
+                                                       print STDERR "mr $action: chain test received signal ".($? & 127)."\n";
+                                               }
+                                       }
+                                       else {
+                                               push @toload, $dir.$section."/.mrconfig";
+                                       }
                                }
                        }
                }
                else {
-                       die "$f line $.: parse error\n";
+                       die "$f line $line: parse error\n";
                }
        }
-       close $in;
 
        foreach (@toload) {
                loadconfig($_);
        }
-}
+} #}}}
 
-sub modifyconfig {
+sub modifyconfig { #{{{
        my $f=shift;
        # the section to modify or add
        my $targetsection=shift;
@@ -563,6 +835,13 @@ sub modifyconfig {
                close $in;
        }
 
+       my $formatfield=sub {
+               my $field=shift;
+               my @value=split(/\n/, shift);
+
+               return "$field = ".shift(@value)."\n".
+                       join("", map { "\t$_\n" } @value);
+       };
        my $addfields=sub {
                my @blanks;
                while ($out[$#out] =~ /^\s*$/) {
@@ -571,6 +850,7 @@ sub modifyconfig {
                foreach my $field (sort keys %changefields) {
                        if (length $changefields{$field}) {
                                push @out, "$field = $changefields{$field}\n";
+                               delete $changefields{$field};
                        }
                }
                push @out, @blanks;
@@ -583,7 +863,7 @@ sub modifyconfig {
                if (/^\s*\#/ || /^\s*$/) {
                        push @out, $_;
                }
-               elsif (/^\s*\[([^\]]*)\]\s*$/) {
+               elsif (/^\[([^\]]*)\]\s*$/) {
                        if (defined $section && 
                            $section eq $targetsection) {
                                $addfields->();
@@ -593,13 +873,14 @@ sub modifyconfig {
 
                        push @out, $_;
                }
-               elsif (/^\s*(\w+)\s*=\s(.*)/) {
+               elsif (/^(\w+)\s*=\s(.*)/) {
                        my $parameter=$1;
                        my $value=$2;
 
-                       # continuation line
-                       while ($value=~/(.*\\)$/s) {
-                               $value=$1."\n".shift(@lines);
+                       # continued value
+                       while (@lines && $lines[0]=~/^\s(.+)/) {
+                               shift(@lines);
+                               $value.="\n$1";
                                chomp $value;
                        }
 
@@ -612,19 +893,19 @@ sub modifyconfig {
                                }
                        }
 
-                       push @out, "$parameter = $value\n";
+                       push @out, $formatfield->($parameter, $value);
                }
        }
 
        if (defined $section && 
            $section eq $targetsection) {
-                       $addfields->();
+               $addfields->();
        }
        elsif (%changefields) {
                push @out, "\n[$targetsection]\n";
                foreach my $field (sort keys %changefields) {
                        if (length $changefields{$field}) {
-                               push @out, "$field = $changefields{$field}\n";
+                               push @out, $formatfield->($field, $changefields{$field});
                        }
                }
        }
@@ -632,122 +913,172 @@ sub modifyconfig {
        open(my $out, ">", $f) || die "mr: write $f: $!\n";
        print $out @out;
        close $out;     
-}
+} #}}}
 
 # Finally, some useful actions that mr knows about by default.
 # These can be overridden in ~/.mrconfig.
+#DATA{{{
 __DATA__
 [ALIAS]
-       co = checkout
-       ci = commit
-       ls = list
+co = checkout
+ci = commit
+ls = list
 
 [DEFAULT]
-lib =                                                  \
-       error() {                                       \
-               echo "mr: $@" >&2                       \
-               exit 1                                  \
-       }
-
-update =                                               \
-       if [ -d "$MR_REPO"/.svn ]; then                 \
-               svn update "$@"                         \
-       elif [ -d "$MR_REPO"/.git ]; then               \
-               git pull origin master "$@"             \
-       elif [ -d "$MR_REPO"/.bzr ]; then               \
-               bzr merge "$@"                          \
-       elif [ -d "$MR_REPO"/CVS ]; then                \
-               cvs update "$@"                         \
-       else                                            \
-               error "unknown repo type"               \
+order = 10
+lib =
+       error() {
+               echo "mr: $@" >&2
+               exit 1
+       }
+       hours_since() {
+               if [ -z "$1" ] || [ -z "$2" ]; then
+                       error "mr: usage: hours_since action num"
+               fi
+               for dir in .git .svn .bzr CVS .hg; do
+                       if [ -e "$MR_REPO/$dir" ]; then
+                               flagfile="$MR_REPO/$dir/.mr_last$1"
+                               break
+                       fi
+               done
+               if [ -z "$flagfile" ]; then
+                       error "cannot determine flag filename"
+               fi
+               delta=$(perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile")
+               if [ "$delta" -lt "$2" ]; then
+                       exit 0
+               else
+                       touch "$flagfile"
+                       exit 1
+               fi
+       }
+
+update =
+       if [ -d "$MR_REPO"/.svn ]; then
+               svn update "$@"
+       elif [ -d "$MR_REPO"/.git ]; then
+               if [ -z "$@" ]; then
+                       git pull -t origin master
+               else
+                       git pull "$@"
+               fi
+       elif [ -d "$MR_REPO"/.bzr ]; then
+               bzr merge "$@"
+       elif [ -d "$MR_REPO"/CVS ]; then
+               cvs update "$@"
+       elif [ -d "$MR_REPO"/.hg ]; then
+               hg pull "$@" && hg update "$@"
+       else
+               error "unknown repo type"
+       fi
+status =
+       if [ -d "$MR_REPO"/.svn ]; then
+               svn status "$@"
+       elif [ -d "$MR_REPO"/.git ]; then
+               git status "$@" || true
+       elif [ -d "$MR_REPO"/.bzr ]; then
+               bzr status "$@"
+       elif [ -d "$MR_REPO"/CVS ]; then
+               cvs status "$@"
+       elif [ -d "$MR_REPO"/.hg ]; then
+               hg status "$@"
+       else
+               error "unknown repo type"
+       fi
+commit =
+       if [ -d "$MR_REPO"/.svn ]; then
+               svn commit "$@"
+       elif [ -d "$MR_REPO"/.git ]; then
+               git commit -a "$@" && git push --all
+       elif [ -d "$MR_REPO"/.bzr ]; then
+               bzr commit "$@" && bzr push
+       elif [ -d "$MR_REPO"/CVS ]; then
+               cvs commit "$@"
+       elif [ -d "$MR_REPO"/.hg ]; then
+               hg commit -m "$@" && hg push
+       else
+               error "unknown repo type"
        fi
-status =                                               \
-       if [ -d "$MR_REPO"/.svn ]; then                 \
-               svn status "$@"                         \
-       elif [ -d "$MR_REPO"/.git ]; then               \
-               git status "$@" || true                 \
-       elif [ -d "$MR_REPO"/.bzr ]; then               \
-               bzr status "$@"                         \
-       elif [ -d "$MR_REPO"/CVS ]; then                \
-               cvs status "$@"                         \
-       else                                            \
-               error "unknown repo type"               \
+diff =
+       if [ -d "$MR_REPO"/.svn ]; then
+               svn diff "$@"
+       elif [ -d "$MR_REPO"/.git ]; then
+               git diff "$@"
+       elif [ -d "$MR_REPO"/.bzr ]; then
+               bzr diff "$@"
+       elif [ -d "$MR_REPO"/CVS ]; then
+               cvs diff "$@"
+       elif [ -d "$MR_REPO"/.hg ]; then
+               hg diff "$@"
+       else
+               error "unknown repo type"
        fi
-commit =                                               \
-       if [ -d "$MR_REPO"/.svn ]; then                 \
-               svn commit "$@"                         \
-       elif [ -d "$MR_REPO"/.git ]; then               \
-               git commit -a "$@" && git push --all    \
-       elif [ -d "$MR_REPO"/.bzr ]; then               \
-               bzr commit "$@" && bzr push             \
-       elif [ -d "$MR_REPO"/CVS ]; then                \
-               cvs commit "$@"                         \
-       else                                            \
-               error "unknown repo type"               \
+log =
+       if [ -d "$MR_REPO"/.svn ]; then
+               svn log"$@"
+       elif [ -d "$MR_REPO"/.git ]; then
+               git log "$@"
+       elif [ -d "$MR_REPO"/.bzr ]; then
+               bzr log "$@"
+       elif [ -d "$MR_REPO"/CVS ]; then
+               cvs log "$@"
+       elif [ -d "$MR_REPO"/.hg ]; then
+               hg log "$@"
+       else
+               error "unknown repo type"
        fi
-diff =                                                 \
-       if [ -d "$MR_REPO"/.svn ]; then                 \
-               svn diff "$@"                           \
-       elif [ -d "$MR_REPO"/.git ]; then               \
-               git diff "$@"                           \
-       elif [ -d "$MR_REPO"/.bzr ]; then               \
-               bzr diff "$@"                           \
-       elif [ -d "$MR_REPO"/CVS ]; then                \
-               cvs diff "$@"                           \
-       else                                            \
-               error "unknown repo type"               \
+register =
+       if [ -n "$1" ]; then
+               cd "$1"
        fi
-log =                                                  \
-       if [ -d "$MR_REPO"/.svn ]; then                 \
-               svn log"$@"                             \
-       elif [ -d "$MR_REPO"/.git ]; then               \
-               git log "$@"                            \
-       elif [ -d "$MR_REPO"/.bzr ]; then               \
-               bzr log "$@"                            \
-       elif [ -d "$MR_REPO"/CVS ]; then                \
-               cvs log "$@"                            \
-       else                                            \
-               error "unknown repo type"               \
+       basedir="$(basename $(pwd))"
+       if [ -d .svn ]; then
+               url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
+               if [ -z "$url" ]; then
+                       error "cannot determine svn url"
+               fi
+               echo "Registering svn url: $url in $MR_CONFIG"
+               mr -c "$MR_CONFIG" config "$(pwd)" checkout="svn co $url $basedir"
+       elif [ -d .git ]; then
+               url=$(LANG=C git-config --get remote.origin.url)
+               if [ -z "$url" ]; then
+                       error "cannot determine git url"
+               fi
+               echo "Registering git url: $url in $MR_CONFIG"
+               mr -c "$MR_CONFIG" config "$(pwd)" checkout="git clone $url $basedir"
+       elif [ -d .bzr ]; then
+               url=$(cat .bzr/branch/parent)
+               if [ -z "$url" ]; then
+                       error "cannot determine bzr url"
+               fi
+               echo "Registering bzr url: $url in $MR_CONFIG"
+               mr -c "$MR_CONFIG" config "$(pwd)" checkout="bzr clone $url $basedir"
+       elif [ -d CVS ]; then
+               repo=$(cat CVS/Repository)
+               root=$(cat CVS/Root)
+               if [ -z "$root" ]; then
+                       error "cannot determine cvs root"
+               fi
+               echo "Registering cvs repository $repo at root $root"
+               mr -c "$MR_CONFIG" config "$(pwd)" \
+                       checkout="cvs -d '$root' co -d $basedir $repo"
+       elif [ -d .hg ]; then
+               url=$(hg showconfig paths.default)
+               echo "Registering mercurial repo url: $url in $MR_CONFIG"
+               mr -c "$MR_CONFIG" config "$(pwd)" \
+                       checkout="hg clone $url $basedir"
+       else
+               error "unable to register this repo type"
        fi
-register =                                                             \
-       if [ -z "$1" ]; then                                            \
-               error "repository directory not specified"              \
-       fi                                                              \
-       cd "$1"                                                         \
-       basedir="$(basename $(pwd))"                                    \
-       if [ -d .svn ]; then                                            \
-               url=$(svn info . |                                      \
-                     grep -i ^URL: | cut -d ' ' -f 2)                  \
-               if [ -z "$url" ]; then                                  \
-                       error "cannot determine svn url"                \
-               fi                                                      \
-               echo "Registering svn url: $url"                        \
-               mr config "$(pwd)" checkout="svn co $url $basedir"      \
-       elif [ -d .git ]; then                                          \
-               url=$(git-config --get remote.origin.url)               \
-               if [ -z "$url" ]; then                                  \
-                       error "cannot determine git url"                \
-               fi                                                      \
-               echo "Registering git url: $url"                        \
-               mr config "$(pwd)" checkout="git clone $url $basedir"   \
-       elif [ -d .bzr ]; then                                          \
-               url=$(cat .bzr/branch/parent)                           \
-               if [ -z "$url" ]; then                                  \
-                       error "cannot determine bzr url"                \
-               fi                                                      \
-               echo "Registering bzr url: $url"                        \
-               mr config "$(pwd)" checkout="bzr clone $url $basedir"   \
-       else                                                            \
-               error "unable to register this repo type"               \
+help =
+       if [ ! -e "$MR_PATH" ]; then
+               error "cannot find program path"
        fi
+       (pod2man -c mr "$MR_PATH" | man -l -) || error "pod2man or man failed"
 list = true
 config = 
-help =                                                 \
-       if [ ! -e "$MR_PATH" ]; then                    \
-               error "cannot find program path"        \
-       fi                                              \
-       (pod2man -c mr "$MR_PATH" | man -l -) ||        \
-               error "pod2man or man failed"
 
 ed = echo "A horse is a horse, of course, of course.."
 T = echo "I pity the fool."
+right = echo "Not found."
+#}}}